#!/bin/sh
# SPDX-License-Identifier: GPL-2.0

BYTES=4

RAND=$(od -A n -t x1 -N "$BYTES" -v /dev/urandom | tr -d ' \n')
HASH=$(echo "$RAND" | sha256sum | cut -d" " -f1 | tr -d ' \n' | cut -c1-5)

cat<<EOF
/*
 * Automatically generated file, do not edit!
 */

#define CRED_CANARY		0x${RAND}U
#define CRED_CANARY_HASH	"$HASH"
EOF
