/*
 * Copyright 2012-2020 by PaX Team <pageexec@freemail.hu>
 * Licensed under the GPL v2
 *
 * Homepage: http://pax.grsecurity.net/
 */

#include "rap.h"

void check_register_variable(tree var)
{
	rtx reg;

	gcc_assert(DECL_P(var));
	if (!DECL_REGISTER(var) || !DECL_ASSEMBLER_NAME_SET_P(var))
		return;

	if (!DECL_RTL(var))
		return;

	reg = DECL_RTL(var);
	if (!REG_P(reg))
		return;

	if (rap_reg_id != ORIGINAL_REGNO(reg))
		return;

	error_at(DECL_SOURCE_LOCATION(var), "variable %qD uses a reserved RAP register %s", var, rap_reg_name);
}

static unsigned int rap_check_local_register_variables_execute(void)
{
	tree var;
	unsigned int i;

	FOR_EACH_LOCAL_DECL(cfun, i, var)
		check_register_variable(var);

	return 0;
}

#define PASS_NAME rap_check_local_register_variables
#define NO_GATE
#include "gcc-generate-gimple-pass.h"
