/*
 * Copyright 2022 by PaX Team <pageexec@freemail.hu>
 * Licensed under the GPL v2
 *
 * move marked automatic (local) variables off the stack
 *
 * a mark is either a type attribute where all instances of the type must be moved,
 * or a variable attribute for a specific variable,
 * or a function attribute marking pointer arguments whose targets must be moved
 *
 * an IPA pass helps propagate the function arg attribute to actual variables,
 * the rest needs manual annotation
 *
 * use case: private (unreadable) kernel stacks don't allow access from foreign threads
 *           so wait and other structures must not be allocated there
 */

#include "utilities.h"
#include "gcc-ksyms.h"


// the meat: IPA/LTO propagation
static unsigned int ipa_discover_nolocal_variables_execute(void)
{
//	nolocal_generate_summary();
	return 0;
}

#define PASS_NAME ipa_discover_nolocal_variables
#define NO_WRITE_SUMMARY
#define NO_GENERATE_SUMMARY
#define NO_READ_SUMMARY
#define NO_READ_OPTIMIZATION_SUMMARY
#define NO_WRITE_OPTIMIZATION_SUMMARY
#define NO_STMT_FIXUP
#define NO_FUNCTION_TRANSFORM
#define NO_VARIABLE_TRANSFORM
#define NO_GATE
//#define NO_EXECUTE
#include "gcc-generate-ipa-pass.h"

static unsigned int early_discover_nolocal_variables_execute(void)
{
//	nolocal_analyze();
	return 0;
}

#define PASS_NAME early_discover_nolocal_variables
#define NO_GATE
#define PROPERTIES_REQUIRED PROP_cfg
#define TODO_FLAGS_FINISH TODO_verify_ssa | TODO_verify_stmts | TODO_dump_func | TODO_update_ssa | TODO_ggc_collect | TODO_verify_flow
#include "gcc-generate-gimple-pass.h"
